//
//  FollowersInteractor.swift
//  VKExt
//
//  Created Ярослав Стрельников on 31.07.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

class FollowersInteractor: FollowersInteractorProtocol {
    weak var presenter: FollowersPresenterProtocol?
    var service: FriendsService?
    var hasNext: Bool = true

    func start(request: FriendModel.Request.RequestType) {
        makeRequest(request: request)
    }
    
    func makeRequest(request: FriendModel.Request.RequestType) {
        if service == nil {
            service = FriendsService()
        }

        switch request {
        case .getFollowers(let userId):
            presenter?.presentData(response: .presentFooterLoader)
            service?.getFollowers(userId: userId, completion: { [weak self] (friends) in
                guard let self = self else { return }
                if friends.items?.count ?? 0 == friends.count ?? 0 {
                    self.hasNext = false
                }
                self.presenter?.presentData(response: .presentFriend(response: friends))
                }, failed: { [weak self] error in
                    guard let self = self else { return }
                    self.presenter?.presentData(response: .presentFooterError(message: error))
            })
        case .getNextFollowers(let userId):
            guard hasNext else { return }
            presenter?.presentData(response: .presentFooterLoader)
            service?.getNextFollowers(userId: userId, completion: { [weak self] (friends) in
                guard let self = self else { return }
                if friends.items?.count ?? 0 == friends.count ?? 0 {
                    self.hasNext = false
                }
                self.presenter?.presentData(response: .presentFriend(response: friends))
                }, failed: { [weak self] error in
                    guard let self = self else { return }
                    self.presenter?.presentData(response: .presentFooterError(message: error))
            })
        default:
            break
        }
    }
}
